"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class ShortTandemRepeatDetails(ProtocolElement):
    """
    No documentation
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "repeatedSequence",
        "shortTandemRepeatCoordinates",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_5 import reports as reports_6_8_0

        return {
            "numberOfCopies": reports_6_8_0.NumberOfCopies,
            "shortTandemRepeatCoordinates": reports_6_8_0.Coordinates,
        }

    @classmethod
    def getEmbeddedEnums(cls):
        return {}

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_5 import reports as reports_6_8_0

        return {
            "org.gel.models.report.avro.NumberOfCopies": reports_6_8_0.NumberOfCopies,
            "org.gel.models.report.avro.Coordinates": reports_6_8_0.Coordinates,
            "org.gel.models.report.avro.ShortTandemRepeatDetails": reports_6_8_0.ShortTandemRepeatDetails,
        }

    __slots__ = [
        "repeatedSequence",
        "shortTandemRepeatCoordinates",
        "numberOfCopies",
    ]

    def __init__(
        self,
        repeatedSequence,
        shortTandemRepeatCoordinates,
        numberOfCopies=None,
        validate=None,
        **kwargs
    ):
        """Initialise the reports_6_8_0.ShortTandemRepeatDetails model.

        :param repeatedSequence:
            Repeat motif e.g. CAG
        :type repeatedSequence: str
        :param shortTandemRepeatCoordinates:
            Short tandem repeat coordinates
        :type shortTandemRepeatCoordinates: Coordinates
        :param numberOfCopies:
            Short tandem repeat copy number for each allele
        :type numberOfCopies: None | list[NumberOfCopies]
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "6.8.0"
